<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;

class FpaFaixatabela extends \Doctrine\ORM\EntityRepository {
    
     public function retornaFaixas($mes_competencia){

        $params = array('p_mescompetencia'=>$mes_competencia);
        $FpaFaixatabela = Repositories::FPA_FAIXATABELA;
         
$sql = <<<SQL
    SELECT ft
    		FROM $FpaFaixatabela ft
        WHERE 
    ft.dtinivigencia = 
			(
        		SELECT MAX(ftt.dtinivigencia)
        		FROM $FpaFaixatabela ftt
        		WHERE ftt.dtinivigencia <= :p_mescompetencia			
                AND ft.nrtabelafolha = ftt.nrtabelafolha
			) 
		ORDER BY ft.nrtabelafolha, ft.vrlimitsupfaixa
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }
    
    public function retornaFaixasPorTabela($nrTabelaFolha, $mes_competencia){

        $params = array('p_mescompetencia'=>$mes_competencia, 'nrtabelafolha' => $nrTabelaFolha);
        $FpaFaixatabela = Repositories::FPA_FAIXATABELA;
         
$sql = <<<SQL
    SELECT ft
    		FROM $FpaFaixatabela ft
        WHERE 
        ft.nrtabelafolha IN(:nrtabelafolha) AND
    ft.dtinivigencia = 
			(
        		SELECT MAX(ftt.dtinivigencia)
        		FROM $FpaFaixatabela ftt
        		WHERE ftt.dtinivigencia <= :p_mescompetencia			
                AND ft.nrtabelafolha = ftt.nrtabelafolha
			) 
		ORDER BY ft.nrtabelafolha, ft.vrlimitsupfaixa
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }
    
}